SystemOrganization addCategory: #'Magritte-Squeak-Seaside'!

MAComponent subclass: #MAColorChooser
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Squeak-Seaside'!

!MAColorChooser commentStamp: '<historical>' prior: 0!
MAColorComponent use me to display a beautiful palette!

!MAColorChooser class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:34'!
color: aColor
	^ self new
		color: aColor;
		yourself! !

!MAColorChooser class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MAColorChooser methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
cancel
	self answer: nil! !

!MAColorChooser methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
color
	^ color! !

!MAColorChooser methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
color: aColor
	color := aColor! !

!MAColorChooser methodsFor: 'accessing-dynamic' stamp: 'jf 9/16/2009 11:34'!
palette
	^ WAPlatform current magritteColorClass oldColorPaletteForDepth: 16 extent: 200 @ 100! !

!MAColorChooser methodsFor: 'rendering' stamp: 'lr 7/14/2007 09:01'!
renderContentOn: html
	html map
		callback: [ :point | self answer: (self palette colorAt: point) ];
		with: [ html image form: self palette ]! !

!MAColorChooser methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
save
	self answer: self color! !

!MAPackage class methodsFor: '*magritte-squeak-seaside' stamp: 'jf 9/17/2009 13:05'!
magritteSqueakSeaside
	^ self new
		name: 'Magritte-Squeak-Seaside';
		addDependency: 'Magritte-Seaside';
		yourself! !

MAElementComponent subclass: #MAColorComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Squeak-Seaside'!

!MAColorComponent commentStamp: '<historical>' prior: 0!
Seaside component of MAColorDescription. I display a little box with the current selected color. If you click on the box, a beautiful palette will be displayed thanks to MAColorChooser.!

!MAColorComponent class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:34'!
isAbstract
	^ false! !

!MAColorComponent methodsFor: 'actions' stamp: 'lr 3/9/2006 11:33'!
choose
	self chooser: (MAColorChooser color: self value)! !

!MAColorComponent methodsFor: 'accessing' stamp: 'jf 9/16/2009 11:35'!
form
	| form colorClass |
	colorClass := WAPlatform current magritteColorClass.
	form := Form extent: self width @ self height depth: 32.
	form getCanvas
		drawPolygon: (Array with: 0 @ self height with: 0 @ 0 with: self width @ 0)
			color: colorClass white borderWidth: 0 borderColor: colorClass white;
		drawPolygon: (Array with: 0 @ self height with: self width @ self height with: self width @ 0)
			color: colorClass black borderWidth: 0 borderColor: colorClass white;
		fillRectangle: (0 @ 0 extent: self width @ self height)
			color: self value.
	^ form! !

!MAColorComponent methodsFor: 'testing' stamp: 'lr 4/20/2007 13:37'!
hasLabelId
	^ true! !

!MAColorComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
height
	^ 15! !

!MAColorComponent methodsFor: 'rendering' stamp: 'lr 1/10/2008 16:01'!
renderEditorOn: html
	html imageButton
		id: self labelId;
		callback: [ self choose ];
		attributeAt: 'width' put: self width;
		attributeAt: 'height' put: self height;
		attributeAt: 'src' put: (html context urlForDocument: self form)! !

!MAColorComponent methodsFor: 'rendering' stamp: 'pmm 12/15/2006 17:00'!
renderViewerOn: html
	html image
		id: self labelId;
		form: self form! !

!MAColorComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
value
	^ super value ifNil: [ self description kind transparent ]! !

!MAColorComponent methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:33'!
width
	^ 30! !

!MAColorDescription class methodsFor: '*magritte-squeak-seaside-defaults' stamp: 'lr 3/9/2006 11:33'!
defaultComponentClasses
	^ Array with: MAColorComponent! !
